<template>
  <div class="col-md-10 pt-4">
    <form class="form-material" @submit.prevent="submitForm">
      <div class="form-group">
        <label>App Name</label>
        <input type="text" class="form-control" name="name" v-model="app.name">
        <FormError :field="formErrors.name"></FormError>
      </div>

      <div class="form-group">
        <label>App Description</label>
        <textarea
          name="description"
          id
          cols="30"
          rows="5"
          class="form-control"
          v-model="app.description"
        ></textarea>
      </div>


      <div class="form-group row">
        <div class="col-6">
          <div class="form-check">
            <input
              class="form-check-input"
              type="checkbox"
              v-model="app.settings.always_allow_livechat"
              id="alwaysallow"
            >
            <label class="form-check-label" for="alwaysallow">Always allow live chat</label>
          </div>
        </div>
 
      </div>
      <div class="form-group">
        <label>Maximum chat per agent</label>
        <input type="number" class="form-control" v-model="app.settings.max_livechat">
      </div>

      <div class="form-group">
        <label>Created At</label>
        <input type="text" class="form-control" v-model="app.created_at" readonly>
      </div>
      <button type="submit" class="btn btn-primary form-control capsule">
        <span v-if="loading">
          Updating
          <i class="fas fa-circle-notch fa-spin"></i>
        </span>
        <span v-else>Save</span>
      </button>
    </form>
  </div>
</template>

<script>
import FormError from "@/components/general/FormError";

export default {
  data() {
    return {
      app: {
        name: null,
        description: null,
        created_at: null,
        settings: {}
      },
      loading: false,
      formErrors: {}
    };
  },
  components: {
    FormError
  },
  computed: {
    apiUrl() {
      return this.baseUrl + `/api/${this.$store.getters.appId.hashed}/app`;
    }
  },
  async mounted() {
    let response = await this.$axios.get(this.apiUrl);
    let app = response.data.data.app;
    this.app.name = app.name;
    this.app.description = app.description;
    this.app.created_at = app.created_at;
    this.app.settings = app.settings;
  },
  methods: {
    async submitForm() {
      try {
        let response = await this.$axios.post(this.apiUrl, { ...this.app });
        this.$store.dispatch("app/updateAppData",response.data.data.app)
        this.$notify({
          group: "notif",
          type: "info",
          title: "Info",
          text: response.data.message
        });
      } catch (error) {
        this.formErrors = error.response.data.errors;
        this.$notify({
          group: "error",
          type: "error",
          title: "Error",
          text: error.response.data.message
        });
      }
    }
  }
};
</script>
<style lang="scss" scoped>
.dropdown-toggle::after {
  display: none;
}
select::-ms-expand {
  display: none !important;
}
select {
  border: none;
  -webkit-appearance: none !important;
  appearance: none !important;
}
</style>
